#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <libharkio3.h>

#define bufsiz 4096
#define MAX_LEN 256     /* １行の最大文字数  */

void write_file();
void fileCopy( );
void AttributeCheck( char *s1 );


void help(void)
{
    printf("                                                                    \n");
    printf("                                                                    \n");
    printf("[NAME:]                                                             \n");
    printf("  harktoolcli-mergexmls                                             \n");
    printf("                                                                    \n");
    printf("[Description:]                                                      \n");
    printf("   merge multiple xml files                                         \n");
    printf("                                                                    \n");
    printf("[Usage :]                                                           \n");
    printf(" harktoolcli-mergexmls infile1 infile2 [Argument]                   \n");
    printf("  [Argument]                                                        \n");
    printf("      -o: output file name                 (-o out.xml)  [string]   \n");
	printf("		  - if not output file name , display on the screen     \n");  
}


FILE *infp, *outfp ,*tmpfp;
char buf[bufsiz];
int n = 1;           /*行番号用カウンタ */
int write_flg = 0;
int head_flg  = 0;
int cnt ;
char *p;
char outfile[bufsiz];

typedef struct 
{
	int config;
	int positions;
	int neighbors;
	int channels;
} check_t;

check_t check;

	 
int main(int argc, char *argv[])
{

	harkio_Log_setLevel(harkio_Log_Error);	 

	check.config    = 0 ;
	check.positions = 0 ;
	check.neighbors = 0 ;
	check.channels  = 0 ;


    if( argc == 2 && (strcmp(argv[1] , "--help") == 0) )
    {
        help();
        exit(EXIT_SUCCESS);
    }
    else if(argc < 3 )
    {
        harkio_Log_printf(harkio_Log_Error , "argument error!!" );
        help();
        exit(EXIT_FAILURE);
    }


   write_flg = 0;


    cnt = 1;
    memset(outfile,0,sizeof(outfile));
    
    while(cnt < argc)
    {
        //get output file
        if( strcmp(argv[cnt] , "-o") == 0 )
        {
            strcpy( outfile , argv[cnt+1]);
		    write_flg = 1;
            break;
        }
        cnt++;
    }



	outfp = tmpfile();
    if (outfp == NULL)
    {
        harkio_Log_printf(harkio_Log_Error , "file open error!!" );
        exit(EXIT_FAILURE);
    }



    cnt = 1;

    while(cnt < argc)
    {
        //check output file
        if( strcmp(argv[cnt] , "-o") == 0 )
        {
            cnt++;
            cnt++;
            continue;
        }


        //infile open
        infp  = fopen( argv[cnt], "r");

        if (infp == NULL)
        {
           harkio_Log_printf(harkio_Log_Error , "argument error!!" );
            exit(EXIT_FAILURE);
        }


        /* ファイルから失敗するまで行単位で文字を読み込み */
        while ( ( fgets(buf , sizeof(buf), infp)) != NULL )
        {


            if(  strstr(buf ,"<hark_xml version") != NULL )
            {
                if( head_flg == 0 )
                {
                    write_file();
                }

                head_flg=1;
                continue;
            }


            if( strstr(buf ,"</hark_xml>") != NULL )
            {
                continue;
            }

			AttributeCheck( buf );			

            write_file();
        }

        fclose(infp);
        cnt++;
    }

    memset(buf,0,sizeof(buf));
    sprintf(buf , "%s\n", "</hark_xml>"  );
    write_file();


	rewind( outfp ); /* ファイル位置を先頭に戻す */

	fileCopy();

    fclose(outfp);

    exit(EXIT_SUCCESS);
}










void write_file()
{

    if( write_flg == 1 )
    {
        fprintf( outfp , "%s", buf);
    }
    else
    {
        printf("%d:", n++);
        p = strchr(buf, '\n');
        if( p != NULL ) *p = '\0';
        puts( buf );
    }
}




void fileCopy( )
{

	FILE *fo ;
	char buff[bufsiz];

	if ((fo = fopen(outfile , "w")) == NULL) 
	{
        harkio_Log_printf(harkio_Log_Error , "file open error!!" );
        exit(EXIT_FAILURE);
	}

	memset(buff ,0,sizeof(buff));
	while( fgets( buff , sizeof(buff)-1 , outfp ) != NULL )
	{
		fputs( buff , fo);
		memset(buff ,0,sizeof(buff));
	}

	fclose(fo);

}




void AttributeCheck( char *s1 )
{

	if( strstr(s1, "<config>") != NULL ) 
	{
		if( check.config == 0 )
		{
			check.config = 1 ;
		}
		else
		{
           harkio_Log_printf(harkio_Log_Error , "<config> Attribute duplicated!!" );
           exit(EXIT_FAILURE);
		}	
	}


	if( strstr(s1, "<positions>") != NULL ) 
	{
		if( check.positions == 0 )
		{
			check.positions = 1 ;
		}
		else
		{
           harkio_Log_printf(harkio_Log_Error , "<positions> Attribute duplicated!!" );
           exit(EXIT_FAILURE);
		}	
	}

	if( strstr(s1, "<neighbors>") != NULL ) 
	{
		if( check.neighbors == 0 )
		{
			check.neighbors = 1 ;
		}
		else
		{
           harkio_Log_printf(harkio_Log_Error , "<neighbors> Attribute duplicated!!" );
           exit(EXIT_FAILURE);
		}	
	}

	if( strstr(s1, "<channels>")  != NULL ) 
	{
		if( check.channels == 0 )
		{
			check.channels = 1 ;
		}
		else
		{
           harkio_Log_printf(harkio_Log_Error , "<channels> Attribute duplicated!!" );
           exit(EXIT_FAILURE);
		}	
	}
}



